<style>
  .OtherCourseNum {
    display: inline-block;
    width: 25px;
    height: 25px;
    text-align: center;
    line-height: 25px;
    border: 1px solid #2961FE;
    border-radius: 50%;
    cursor: pointer;
    color: #2961FE;
  }

  .OCourseTable {
    width: 400px;
    text-align: center;
  }

  .OCourseTable tr td {
    height: 40px;
  }

  .OCourseTable tr th {
    height: 40px;
    background-color: rgb(238, 238, 239);
  }

  .Exam_PaperName {
    width: 300px;
    display: inline;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }

  .Exam_PaperName i {
    font-size: 18px;
  }

  .examPaper .el-table th {
    background-color: #F5F6F7;
  }

  .examPNav {
    margin: 10px 0;
    color: #3A8BFF;
    font-size: 12px;
  }

  .examPNav span {
    cursor: pointer;
  }

  .examPNav span:hover {
    text-decoration: underline;
  }

  .lastExam {
    color: #6B89B3;
    cursor: default !important;
    pointer-events: none;
  }
  .disabled-column .el-checkbox__input{
    display:none;
  }
</style>
<!--试卷库管理-->
<template>
  <div class="page-body">
    <div class="page-search row items-center">
      <div class="col row wrap q-mr-lg q-col-gutter-md">
        <div class="col-3">
          <q-input @change="getList" clearable filled v-model="msg.PaperName" @clear="getList" maxlength="20"
            label="输入试卷名称、组卷人查找" />
        </div>
      </div>
      <div class="page-option">
        <q-btn color="accent" size="sm" v-if="IsCreateFolder" class="q-mr-md" label="新增文件夹"
          @click="showExamFolder(null)" />
        <q-btn-dropdown flat size="xs" color="dark" label="新增试卷" v-if="IsCreatePaper" style="margin-left:10px;">
          <q-list>
            <q-item clickable v-close-popup @click="CreatePaper()">
              <q-item-section>
                <q-item-label>智能组卷</q-item-label>
              </q-item-section>
            </q-item>
            <q-item clickable v-close-popup @click="goExameEdit(null)">
              <q-item-section>
                <q-item-label>手动组卷</q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-btn-dropdown>
      </div>
    </div>
    <div class="page-content examPaper">
      <div v-if="navList&&navList.length>0" class="examPNav">
        <span @click="getPaperChild(0)">全部</span> >
        <template v-for="(item,index) in navList">
          <span @click="getPaperChild(item.PaperId)" :class="{'lastExam':index==navList.length-1}" :key="index">
            {{item.PaperName}}
          </span>
          <span v-if="index!=navList.length-1" :key="index">></span>
        </template>
      </div>
      <examPaperForm :dataList="dataList" ref="examPaper" :loading="loading"></examPaperForm>
      <q-pagination class="full-width justify-end" v-model="msg.pageIndex" color="primary" :max="pageCount"
        :input="true" @input="changePage" />
    </div>
  </div>
</template>
<script>
  import examPaperForm from '../../components/exam/exam-paperform'
  import {
    GetPaperPage,
    deletePaperInfo,
    copyPaperInfo,
    submitApproval
  } from '../../api/teacher/index';
  //获取校区列表
  export default {
    components: {
      examPaperForm
    },
    meta: {
      title: "考试管理"
    },
    data() {
      return {
        data: [],
        msg: {
          pageIndex: 1,
          pageSize: 10,
          rowsPerPage: 10,
          PaperName: '', //题库名
          ParentId: 0,
        },
        pageCount: 0,
        loading: false,
        dataList: [],
        isShowExamFolder: false, //是否显示新增文件夹
        isShowMoveFolder: false, //是否显示
        isShowSetOpenFolder: false, //是否显示设置权限
        examObj: {}, //弹窗对象
        navList: [], //导航列表
        IsCreateFolder: false, //是否试卷创建文件夹权限
        IsCreatePaper: false, //是否创建试卷权限
        MoveIds: '',
        currentUserInfo: {}, //当前登录用户
        commonAccountId:-1,
      }
    },
    created() {
      let userinfo = this.getLocalStorage();
      this.currentUserInfo = userinfo;
      userinfo.ActionMenuList.map(x => { //判断权限
        if (x.FunctionCode == "Paper_CreateManager") { //判断是否试卷创建文件夹权限
          this.IsCreateFolder = true;
        }
        if (x.FunctionCode == "Paper_CreatePaper") { //判断是否有创建试卷权限
          this.IsCreatePaper = true;
        }
      })
    },
    mounted() {
      this.getList();
    },
    methods: {
      rowsClick(row, column, event) {
        this.$refs.examPaperTab.toggleRowExpansion(row);
      },
      //创建试卷
      CreatePaper() {
        this.OpenNewUrl('/exam/paperCreate', {
          ToParentId: this.msg.ParentId
        })
      },
      //翻页
      changePage(val) {
        this.msg.pageIndex = val;
        this.getList()
      },
      getPaperChild(Id) {
        this.msg.ParentId = Id;
        this.refreshPage();
      },
      //获取菜单分页列表
      getList() {
        this.loading = true;
        this.dataList = [];
        GetPaperPage(this.msg).then(res => {

          this.loading = false;
          if (res.Code == 1) {
            this.dataList = res.Data.pageModel.PageData;
            this.pageCount = res.Data.pageModel.PageCount;
            this.navList = res.Data.navList;
          }
        }).catch(() => {
          this.loading = false
        })
      },
      //刷新页面
      refreshPage() {
        this.getList();
      },
      //点击编辑 跳转
      goExameEdit(item) {
        var obj = {
          Id: 0,
          ToParentId: this.msg.ParentId
        }
        if (item) {
          obj.Id = item.PaperId;
          obj.ToParentId = item.ParentId;
        }
        this.OpenNewUrl('/exam/paperEdit', obj)
      },
      //新增修改文件夹
      showExamFolder(obj) {
        this.examObj = obj;
        this.isShowExamFolder = true;
      },
      //实在开放权限
      showOpenForm(obj) {
        this.examObj = obj;
        this.isShowSetOpenFolder = true;
      },
      //关闭弹窗
      closeExamForm() {
        this.isShowExamFolder = false;
        this.isShowMoveFolder = false;
        this.isShowSetOpenFolder = false;
      },
      //发布考试
      publishExam(item) {
        let PaperId = 0;
        if (item) {
          PaperId = item.PaperId
        }
        this.OpenNewUrl('/exam/paperPublish', {
          PaperId: PaperId
        })
      },
      //试卷详情
      showPaperInfo(item) {
        let PaperId = 0;
        if (item) {
          PaperId = item.PaperId
        }
        this.OpenNewUrl('/exam/paperInfo', {
          Id: PaperId
        })
      },
      //移动到文件夹
      movePaperInfo(item) {
        this.examObj = item;
        this.isShowMoveFolder = true;
      },
      //复制试卷
      copyPaperInfo(item) {
        var msg = {
          PaperId: item.PaperId
        }
        var message = "是否要复制【" + item.PaperName + "】试卷?";
        this.$q.dialog({
          title: '提示信息',
          message: message,
          cancel: true,
          persistent: true,
          ok: "确定",
          cancel: "取消",
        }).onOk(() => {
          copyPaperInfo(msg).then(res => {
            if (res.Code == 1) {
              this.$q.notify({
                icon: 'iconfont icon-chenggong',
                color: 'accent',
                timeout: 2000,
                message: '操作成功!',
                position: 'top'
              })
              this.refreshPage();
            }
          });
        })
      },
      //批量删除
      batchDelete() {
        var msg = {
          PaperIds: this.MoveIds
        }
        var message = "是否要删除选中的文件信息";
        this.deletePaperCommon(msg, message);
      },
      //删除
      deletePaperInfo(item) {
        var msg = {
          PaperId: item.PaperId
        }
        var message = "";
        if (item.PaperType == 1) {
          message = "是否要删除【" + item.PaperName + "】及下面的内容?";
        } else {
          message = "是否要删除【" + item.PaperName + "】试卷?"
        }
        this.deletePaperCommon(msg, message);
      },
      deletePaperCommon(msg, tipMsg) {
        this.$q.dialog({
          title: '提示信息',
          message: tipMsg,
          cancel: true,
          persistent: true,
          ok: "确定",
          cancel: "取消",
        }).onOk(() => {
          deletePaperInfo(msg).then(res => {
            if (res.Code == 1) {
              this.$q.notify({
                icon: 'iconfont icon-chenggong',
                color: 'accent',
                timeout: 2000,
                message: '操作成功!',
                position: 'top'
              })
              this.refreshPage();
            }
          });
        })
      }

    }
  }

</script>
<style lang="sass">
  @import url('~assets/css/table.sass')

</style>
